// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let WorkspaceParameters = require('./WorkspaceParameters.js');
let RobotState = require('./RobotState.js');
let Constraints = require('./Constraints.js');

//-----------------------------------------------------------

class MotionPlanRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.workspace_parameters = null;
      this.start_state = null;
      this.goal_constraints = null;
      this.path_constraints = null;
      this.planner_id = null;
      this.group_name = null;
      this.num_planning_attempts = null;
      this.allowed_planning_time = null;
      this.expected_path_duration = null;
      this.expected_path_dt = null;
    }
    else {
      if (initObj.hasOwnProperty('workspace_parameters')) {
        this.workspace_parameters = initObj.workspace_parameters
      }
      else {
        this.workspace_parameters = new WorkspaceParameters();
      }
      if (initObj.hasOwnProperty('start_state')) {
        this.start_state = initObj.start_state
      }
      else {
        this.start_state = new RobotState();
      }
      if (initObj.hasOwnProperty('goal_constraints')) {
        this.goal_constraints = initObj.goal_constraints
      }
      else {
        this.goal_constraints = new Constraints();
      }
      if (initObj.hasOwnProperty('path_constraints')) {
        this.path_constraints = initObj.path_constraints
      }
      else {
        this.path_constraints = new Constraints();
      }
      if (initObj.hasOwnProperty('planner_id')) {
        this.planner_id = initObj.planner_id
      }
      else {
        this.planner_id = '';
      }
      if (initObj.hasOwnProperty('group_name')) {
        this.group_name = initObj.group_name
      }
      else {
        this.group_name = '';
      }
      if (initObj.hasOwnProperty('num_planning_attempts')) {
        this.num_planning_attempts = initObj.num_planning_attempts
      }
      else {
        this.num_planning_attempts = 0;
      }
      if (initObj.hasOwnProperty('allowed_planning_time')) {
        this.allowed_planning_time = initObj.allowed_planning_time
      }
      else {
        this.allowed_planning_time = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('expected_path_duration')) {
        this.expected_path_duration = initObj.expected_path_duration
      }
      else {
        this.expected_path_duration = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('expected_path_dt')) {
        this.expected_path_dt = initObj.expected_path_dt
      }
      else {
        this.expected_path_dt = {secs: 0, nsecs: 0};
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MotionPlanRequest
    // Serialize message field [workspace_parameters]
    bufferOffset = WorkspaceParameters.serialize(obj.workspace_parameters, buffer, bufferOffset);
    // Serialize message field [start_state]
    bufferOffset = RobotState.serialize(obj.start_state, buffer, bufferOffset);
    // Serialize message field [goal_constraints]
    bufferOffset = Constraints.serialize(obj.goal_constraints, buffer, bufferOffset);
    // Serialize message field [path_constraints]
    bufferOffset = Constraints.serialize(obj.path_constraints, buffer, bufferOffset);
    // Serialize message field [planner_id]
    bufferOffset = _serializer.string(obj.planner_id, buffer, bufferOffset);
    // Serialize message field [group_name]
    bufferOffset = _serializer.string(obj.group_name, buffer, bufferOffset);
    // Serialize message field [num_planning_attempts]
    bufferOffset = _serializer.int32(obj.num_planning_attempts, buffer, bufferOffset);
    // Serialize message field [allowed_planning_time]
    bufferOffset = _serializer.duration(obj.allowed_planning_time, buffer, bufferOffset);
    // Serialize message field [expected_path_duration]
    bufferOffset = _serializer.duration(obj.expected_path_duration, buffer, bufferOffset);
    // Serialize message field [expected_path_dt]
    bufferOffset = _serializer.duration(obj.expected_path_dt, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MotionPlanRequest
    let len;
    let data = new MotionPlanRequest(null);
    // Deserialize message field [workspace_parameters]
    data.workspace_parameters = WorkspaceParameters.deserialize(buffer, bufferOffset);
    // Deserialize message field [start_state]
    data.start_state = RobotState.deserialize(buffer, bufferOffset);
    // Deserialize message field [goal_constraints]
    data.goal_constraints = Constraints.deserialize(buffer, bufferOffset);
    // Deserialize message field [path_constraints]
    data.path_constraints = Constraints.deserialize(buffer, bufferOffset);
    // Deserialize message field [planner_id]
    data.planner_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [group_name]
    data.group_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [num_planning_attempts]
    data.num_planning_attempts = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [allowed_planning_time]
    data.allowed_planning_time = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [expected_path_duration]
    data.expected_path_duration = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [expected_path_dt]
    data.expected_path_dt = _deserializer.duration(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += WorkspaceParameters.getMessageSize(object.workspace_parameters);
    length += RobotState.getMessageSize(object.start_state);
    length += Constraints.getMessageSize(object.goal_constraints);
    length += Constraints.getMessageSize(object.path_constraints);
    length += object.planner_id.length;
    length += object.group_name.length;
    return length + 36;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/MotionPlanRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '75408e881303c6ad5069bd5df65ecb00';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This service contains the definition for a request to the motion
    # planner and the output it provides
    
    # Parameters for the workspace that the planner should work inside
    arm_navigation_msgs/WorkspaceParameters workspace_parameters
    
    # Starting state updates. If certain joints should be considered
    # at positions other than the current ones, these positions should
    # be set here
    arm_navigation_msgs/RobotState start_state
    
    # The goal state for the model to plan for. The goal is achieved
    # if all constraints are satisfied
    arm_navigation_msgs/Constraints goal_constraints
    
    # No state at any point along the path in the produced motion plan will violate these constraints
    arm_navigation_msgs/Constraints path_constraints
    
    # The name of the motion planner to use. If no name is specified,
    # a default motion planner will be used
    string planner_id
    
    # The name of the group of joints on which this planner is operating
    string group_name
    
    # The number of times this plan is to be computed. Shortest solution
    # will be reported.
    int32 num_planning_attempts
    
    # The maximum amount of time the motion planner is allowed to plan for
    duration allowed_planning_time
    
    # An expected path duration (in seconds) along with an expected discretization of the path allows the planner to determine the discretization of the trajectory that it returns
    duration expected_path_duration
    duration expected_path_dt
    
    ================================================================================
    MSG: arm_navigation_msgs/WorkspaceParameters
    # This message contains a set of parameters useful in
    # setting up the workspace for planning
    arm_navigation_msgs/Shape  workspace_region_shape
    geometry_msgs/PoseStamped    workspace_region_pose
    
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: arm_navigation_msgs/RobotState
    # This message contains information about the robot state, i.e. the positions of its joints and links
    sensor_msgs/JointState joint_state
    arm_navigation_msgs/MultiDOFJointState multi_dof_joint_state
    
    ================================================================================
    MSG: sensor_msgs/JointState
    # This is a message that holds data to describe the state of a set of torque controlled joints. 
    #
    # The state of each joint (revolute or prismatic) is defined by:
    #  * the position of the joint (rad or m),
    #  * the velocity of the joint (rad/s or m/s) and 
    #  * the effort that is applied in the joint (Nm or N).
    #
    # Each joint is uniquely identified by its name
    # The header specifies the time at which the joint states were recorded. All the joint states
    # in one message have to be recorded at the same time.
    #
    # This message consists of a multiple arrays, one for each part of the joint state. 
    # The goal is to make each of the fields optional. When e.g. your joints have no
    # effort associated with them, you can leave the effort array empty. 
    #
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states.
    
    
    Header header
    
    string[] name
    float64[] position
    float64[] velocity
    float64[] effort
    
    ================================================================================
    MSG: arm_navigation_msgs/MultiDOFJointState
    #A representation of a multi-dof joint state
    time stamp
    string[] joint_names
    string[] frame_ids
    string[] child_frame_ids
    geometry_msgs/Pose[] poses
    
    ================================================================================
    MSG: arm_navigation_msgs/Constraints
    # This message contains a list of motion planning constraints.
    
    arm_navigation_msgs/JointConstraint[] joint_constraints
    arm_navigation_msgs/PositionConstraint[] position_constraints
    arm_navigation_msgs/OrientationConstraint[] orientation_constraints
    arm_navigation_msgs/VisibilityConstraint[] visibility_constraints
    
    ================================================================================
    MSG: arm_navigation_msgs/JointConstraint
    # Constrain the position of a joint to be within a certain bound
    string joint_name
    
    # the bound to be achieved is [position - tolerance_below, position + tolerance_above]
    float64 position
    float64 tolerance_above
    float64 tolerance_below
    
    # A weighting factor for this constraint
    float64 weight
    ================================================================================
    MSG: arm_navigation_msgs/PositionConstraint
    # This message contains the definition of a position constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The offset (in the link frame) for the target point on the link we are planning for
    geometry_msgs/Point target_point_offset
    
    # The nominal/target position for the point we are planning for
    geometry_msgs/Point position
    
    # The shape of the bounded region that constrains the position of the end-effector
    # This region is always centered at the position defined above
    arm_navigation_msgs/Shape constraint_region_shape
    
    # The orientation of the bounded region that constrains the position of the end-effector. 
    # This allows the specification of non-axis aligned constraints
    geometry_msgs/Quaternion constraint_region_orientation
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: arm_navigation_msgs/OrientationConstraint
    # This message contains the definition of an orientation constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The type of the constraint
    int32 type
    int32 LINK_FRAME=0
    int32 HEADER_FRAME=1
    
    # The desired orientation of the robot link specified as a quaternion
    geometry_msgs/Quaternion orientation
    
    # optional RPY error tolerances specified if 
    float64 absolute_roll_tolerance
    float64 absolute_pitch_tolerance
    float64 absolute_yaw_tolerance
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: arm_navigation_msgs/VisibilityConstraint
    # This message contains the definition of a visibility constraint.
    Header header
    
    # The point stamped target that needs to be kept within view of the sensor
    geometry_msgs/PointStamped target
    
    # The local pose of the frame in which visibility is to be maintained
    # The frame id should represent the robot link to which the sensor is attached
    # The visual axis of the sensor is assumed to be along the X axis of this frame
    geometry_msgs/PoseStamped sensor_pose
    
    # The deviation (in radians) that will be tolerated
    # Constraint error will be measured as the solid angle between the 
    # X axis of the frame defined above and the vector between the origin 
    # of the frame defined above and the target location
    float64 absolute_tolerance
    
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MotionPlanRequest(null);
    if (msg.workspace_parameters !== undefined) {
      resolved.workspace_parameters = WorkspaceParameters.Resolve(msg.workspace_parameters)
    }
    else {
      resolved.workspace_parameters = new WorkspaceParameters()
    }

    if (msg.start_state !== undefined) {
      resolved.start_state = RobotState.Resolve(msg.start_state)
    }
    else {
      resolved.start_state = new RobotState()
    }

    if (msg.goal_constraints !== undefined) {
      resolved.goal_constraints = Constraints.Resolve(msg.goal_constraints)
    }
    else {
      resolved.goal_constraints = new Constraints()
    }

    if (msg.path_constraints !== undefined) {
      resolved.path_constraints = Constraints.Resolve(msg.path_constraints)
    }
    else {
      resolved.path_constraints = new Constraints()
    }

    if (msg.planner_id !== undefined) {
      resolved.planner_id = msg.planner_id;
    }
    else {
      resolved.planner_id = ''
    }

    if (msg.group_name !== undefined) {
      resolved.group_name = msg.group_name;
    }
    else {
      resolved.group_name = ''
    }

    if (msg.num_planning_attempts !== undefined) {
      resolved.num_planning_attempts = msg.num_planning_attempts;
    }
    else {
      resolved.num_planning_attempts = 0
    }

    if (msg.allowed_planning_time !== undefined) {
      resolved.allowed_planning_time = msg.allowed_planning_time;
    }
    else {
      resolved.allowed_planning_time = {secs: 0, nsecs: 0}
    }

    if (msg.expected_path_duration !== undefined) {
      resolved.expected_path_duration = msg.expected_path_duration;
    }
    else {
      resolved.expected_path_duration = {secs: 0, nsecs: 0}
    }

    if (msg.expected_path_dt !== undefined) {
      resolved.expected_path_dt = msg.expected_path_dt;
    }
    else {
      resolved.expected_path_dt = {secs: 0, nsecs: 0}
    }

    return resolved;
    }
};

module.exports = MotionPlanRequest;
