// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class OrientationConstraint {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.link_name = null;
      this.type = null;
      this.orientation = null;
      this.absolute_roll_tolerance = null;
      this.absolute_pitch_tolerance = null;
      this.absolute_yaw_tolerance = null;
      this.weight = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('link_name')) {
        this.link_name = initObj.link_name
      }
      else {
        this.link_name = '';
      }
      if (initObj.hasOwnProperty('type')) {
        this.type = initObj.type
      }
      else {
        this.type = 0;
      }
      if (initObj.hasOwnProperty('orientation')) {
        this.orientation = initObj.orientation
      }
      else {
        this.orientation = new geometry_msgs.msg.Quaternion();
      }
      if (initObj.hasOwnProperty('absolute_roll_tolerance')) {
        this.absolute_roll_tolerance = initObj.absolute_roll_tolerance
      }
      else {
        this.absolute_roll_tolerance = 0.0;
      }
      if (initObj.hasOwnProperty('absolute_pitch_tolerance')) {
        this.absolute_pitch_tolerance = initObj.absolute_pitch_tolerance
      }
      else {
        this.absolute_pitch_tolerance = 0.0;
      }
      if (initObj.hasOwnProperty('absolute_yaw_tolerance')) {
        this.absolute_yaw_tolerance = initObj.absolute_yaw_tolerance
      }
      else {
        this.absolute_yaw_tolerance = 0.0;
      }
      if (initObj.hasOwnProperty('weight')) {
        this.weight = initObj.weight
      }
      else {
        this.weight = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type OrientationConstraint
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [link_name]
    bufferOffset = _serializer.string(obj.link_name, buffer, bufferOffset);
    // Serialize message field [type]
    bufferOffset = _serializer.int32(obj.type, buffer, bufferOffset);
    // Serialize message field [orientation]
    bufferOffset = geometry_msgs.msg.Quaternion.serialize(obj.orientation, buffer, bufferOffset);
    // Serialize message field [absolute_roll_tolerance]
    bufferOffset = _serializer.float64(obj.absolute_roll_tolerance, buffer, bufferOffset);
    // Serialize message field [absolute_pitch_tolerance]
    bufferOffset = _serializer.float64(obj.absolute_pitch_tolerance, buffer, bufferOffset);
    // Serialize message field [absolute_yaw_tolerance]
    bufferOffset = _serializer.float64(obj.absolute_yaw_tolerance, buffer, bufferOffset);
    // Serialize message field [weight]
    bufferOffset = _serializer.float64(obj.weight, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type OrientationConstraint
    let len;
    let data = new OrientationConstraint(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [link_name]
    data.link_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [type]
    data.type = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [orientation]
    data.orientation = geometry_msgs.msg.Quaternion.deserialize(buffer, bufferOffset);
    // Deserialize message field [absolute_roll_tolerance]
    data.absolute_roll_tolerance = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [absolute_pitch_tolerance]
    data.absolute_pitch_tolerance = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [absolute_yaw_tolerance]
    data.absolute_yaw_tolerance = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [weight]
    data.weight = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += object.link_name.length;
    return length + 72;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/OrientationConstraint';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '27d99749ba49d4a822298bbd1e0988ba';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message contains the definition of an orientation constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The type of the constraint
    int32 type
    int32 LINK_FRAME=0
    int32 HEADER_FRAME=1
    
    # The desired orientation of the robot link specified as a quaternion
    geometry_msgs/Quaternion orientation
    
    # optional RPY error tolerances specified if 
    float64 absolute_roll_tolerance
    float64 absolute_pitch_tolerance
    float64 absolute_yaw_tolerance
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new OrientationConstraint(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.link_name !== undefined) {
      resolved.link_name = msg.link_name;
    }
    else {
      resolved.link_name = ''
    }

    if (msg.type !== undefined) {
      resolved.type = msg.type;
    }
    else {
      resolved.type = 0
    }

    if (msg.orientation !== undefined) {
      resolved.orientation = geometry_msgs.msg.Quaternion.Resolve(msg.orientation)
    }
    else {
      resolved.orientation = new geometry_msgs.msg.Quaternion()
    }

    if (msg.absolute_roll_tolerance !== undefined) {
      resolved.absolute_roll_tolerance = msg.absolute_roll_tolerance;
    }
    else {
      resolved.absolute_roll_tolerance = 0.0
    }

    if (msg.absolute_pitch_tolerance !== undefined) {
      resolved.absolute_pitch_tolerance = msg.absolute_pitch_tolerance;
    }
    else {
      resolved.absolute_pitch_tolerance = 0.0
    }

    if (msg.absolute_yaw_tolerance !== undefined) {
      resolved.absolute_yaw_tolerance = msg.absolute_yaw_tolerance;
    }
    else {
      resolved.absolute_yaw_tolerance = 0.0
    }

    if (msg.weight !== undefined) {
      resolved.weight = msg.weight;
    }
    else {
      resolved.weight = 0.0
    }

    return resolved;
    }
};

// Constants for message
OrientationConstraint.Constants = {
  LINK_FRAME: 0,
  HEADER_FRAME: 1,
}

module.exports = OrientationConstraint;
