// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let CollisionMap = require('../msg/CollisionMap.js');
let CollisionObject = require('../msg/CollisionObject.js');
let AttachedCollisionObject = require('../msg/AttachedCollisionObject.js');

//-----------------------------------------------------------

class GetCollisionObjectsRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.include_points = null;
    }
    else {
      if (initObj.hasOwnProperty('include_points')) {
        this.include_points = initObj.include_points
      }
      else {
        this.include_points = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetCollisionObjectsRequest
    // Serialize message field [include_points]
    bufferOffset = _serializer.bool(obj.include_points, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetCollisionObjectsRequest
    let len;
    let data = new GetCollisionObjectsRequest(null);
    // Deserialize message field [include_points]
    data.include_points = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a service object
    return 'arm_navigation_msgs/GetCollisionObjectsRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3ae7288b23c84452d229e442c1673708';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    bool include_points
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetCollisionObjectsRequest(null);
    if (msg.include_points !== undefined) {
      resolved.include_points = msg.include_points;
    }
    else {
      resolved.include_points = false
    }

    return resolved;
    }
};

class GetCollisionObjectsResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.points = null;
      this.collision_objects = null;
      this.attached_collision_objects = null;
    }
    else {
      if (initObj.hasOwnProperty('points')) {
        this.points = initObj.points
      }
      else {
        this.points = new CollisionMap();
      }
      if (initObj.hasOwnProperty('collision_objects')) {
        this.collision_objects = initObj.collision_objects
      }
      else {
        this.collision_objects = [];
      }
      if (initObj.hasOwnProperty('attached_collision_objects')) {
        this.attached_collision_objects = initObj.attached_collision_objects
      }
      else {
        this.attached_collision_objects = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetCollisionObjectsResponse
    // Serialize message field [points]
    bufferOffset = CollisionMap.serialize(obj.points, buffer, bufferOffset);
    // Serialize message field [collision_objects]
    // Serialize the length for message field [collision_objects]
    bufferOffset = _serializer.uint32(obj.collision_objects.length, buffer, bufferOffset);
    obj.collision_objects.forEach((val) => {
      bufferOffset = CollisionObject.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [attached_collision_objects]
    // Serialize the length for message field [attached_collision_objects]
    bufferOffset = _serializer.uint32(obj.attached_collision_objects.length, buffer, bufferOffset);
    obj.attached_collision_objects.forEach((val) => {
      bufferOffset = AttachedCollisionObject.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetCollisionObjectsResponse
    let len;
    let data = new GetCollisionObjectsResponse(null);
    // Deserialize message field [points]
    data.points = CollisionMap.deserialize(buffer, bufferOffset);
    // Deserialize message field [collision_objects]
    // Deserialize array length for message field [collision_objects]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.collision_objects = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.collision_objects[i] = CollisionObject.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [attached_collision_objects]
    // Deserialize array length for message field [attached_collision_objects]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.attached_collision_objects = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.attached_collision_objects[i] = AttachedCollisionObject.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += CollisionMap.getMessageSize(object.points);
    object.collision_objects.forEach((val) => {
      length += CollisionObject.getMessageSize(val);
    });
    object.attached_collision_objects.forEach((val) => {
      length += AttachedCollisionObject.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'arm_navigation_msgs/GetCollisionObjectsResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c361b849f4eb74ea667a930b0b9dc801';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    arm_navigation_msgs/CollisionMap points
    
    arm_navigation_msgs/CollisionObject[] collision_objects
    
    arm_navigation_msgs/AttachedCollisionObject[] attached_collision_objects
    
    
    ================================================================================
    MSG: arm_navigation_msgs/CollisionMap
    #header for interpreting box positions
    Header header
    
    #boxes for use in collision testing
    OrientedBoundingBox[] boxes
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: arm_navigation_msgs/OrientedBoundingBox
    #the center of the box
    geometry_msgs/Point32 center
    
    #the extents of the box, assuming the center is at the point
    geometry_msgs/Point32 extents
    
    #the axis of the box
    geometry_msgs/Point32 axis
    
    #the angle of rotation around the axis
    float32 angle
    
    ================================================================================
    MSG: geometry_msgs/Point32
    # This contains the position of a point in free space(with 32 bits of precision).
    # It is recommeded to use Point wherever possible instead of Point32.  
    # 
    # This recommendation is to promote interoperability.  
    #
    # This message is designed to take up less space when sending
    # lots of points at once, as in the case of a PointCloud.  
    
    float32 x
    float32 y
    float32 z
    ================================================================================
    MSG: arm_navigation_msgs/CollisionObject
    # a header, used for interpreting the poses
    Header header
    
    # the id of the object
    string id
    
    # The padding used for filtering points near the object.
    # This does not affect collision checking for the object.  
    # Set to negative to get zero padding.
    float32 padding
    
    #This contains what is to be done with the object
    CollisionObjectOperation operation
    
    #the shapes associated with the object
    arm_navigation_msgs/Shape[] shapes
    
    #the poses associated with the shapes - will be transformed using the header
    geometry_msgs/Pose[] poses
    
    ================================================================================
    MSG: arm_navigation_msgs/CollisionObjectOperation
    #Puts the object into the environment
    #or updates the object if already added
    byte ADD=0
    
    #Removes the object from the environment entirely
    byte REMOVE=1
    
    #Only valid within the context of a CollisionAttachedObject message
    #Will be ignored if sent with an CollisionObject message
    #Takes an attached object, detaches from the attached link
    #But adds back in as regular object
    byte DETACH_AND_ADD_AS_OBJECT=2
    
    #Only valid within the context of a CollisionAttachedObject message
    #Will be ignored if sent with an CollisionObject message
    #Takes current object in the environment and removes it as
    #a regular object
    byte ATTACH_AND_REMOVE_AS_OBJECT=3
    
    # Byte code for operation
    byte operation
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: arm_navigation_msgs/AttachedCollisionObject
    # The CollisionObject will be attached with a fixed joint to this link
    # If link name is set to REMOVE_ALL_ATTACHED_OBJECTS and object.operation 
    # is set to REMOVE will remove all attached bodies attached to any object
    string link_name
    
    #Reserved for indicating that all attached objects should be removed
    string REMOVE_ALL_ATTACHED_OBJECTS = "all"
    
    #This contains the actual shapes and poses for the CollisionObject
    #to be attached to the link
    #If action is remove and no object.id is set, all objects
    #attached to the link indicated by link_name will be removed
    CollisionObject object
    
    # The set of links that the attached objects are allowed to touch
    # by default - the link_name is included by default
    string[] touch_links
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetCollisionObjectsResponse(null);
    if (msg.points !== undefined) {
      resolved.points = CollisionMap.Resolve(msg.points)
    }
    else {
      resolved.points = new CollisionMap()
    }

    if (msg.collision_objects !== undefined) {
      resolved.collision_objects = new Array(msg.collision_objects.length);
      for (let i = 0; i < resolved.collision_objects.length; ++i) {
        resolved.collision_objects[i] = CollisionObject.Resolve(msg.collision_objects[i]);
      }
    }
    else {
      resolved.collision_objects = []
    }

    if (msg.attached_collision_objects !== undefined) {
      resolved.attached_collision_objects = new Array(msg.attached_collision_objects.length);
      for (let i = 0; i < resolved.attached_collision_objects.length; ++i) {
        resolved.attached_collision_objects[i] = AttachedCollisionObject.Resolve(msg.attached_collision_objects[i]);
      }
    }
    else {
      resolved.attached_collision_objects = []
    }

    return resolved;
    }
};

module.exports = {
  Request: GetCollisionObjectsRequest,
  Response: GetCollisionObjectsResponse,
  md5sum() { return '8a4f57995c7be09c22ca01de6eb557ac'; },
  datatype() { return 'arm_navigation_msgs/GetCollisionObjects'; }
};
